

function [Puzzle,Puz_Possibilities,Blank_Mat]=A(Puzzle)
global CONSTANTS

%% ID blanks
[m,n]=find(Puzzle==0);  %identifies row/clmn of blanks
Index=find(Puzzle==0);  %identifies linear index of blanks
PuzSqID=PuzzleSquareIdentifier(Puzzle); %identifies the square ID's of puzzle
Blanks_SquareID=SquareID(Index);    %identifies the Box of blanks
Puz_Possibilities{9,9}=[];

Blank_Mat=[m n Blanks_SquareID Index];
%% Possible answers for all blanks
for i=1:length(m)
    row=m(i);
    clmn=n(i);
    box=Blanks_SquareID(i);
    Puz_Possibilities=filler(Puzzle,Puz_Possibilities,PuzSqID,row,clmn,box);
    
end

for i=1:CONSTANTS.Size^2
if isempty(Puz_Possibilities{i})
    Puz_Possibilities{i}=zeros(1,9);
end
end

end


%% Possibilities finder
function Puz_Possibilities=filler(Puzzle,Puz_Possibilities,PuzSqID,m,n,box)
global CONSTANTS
Puz_Possibilities{m,n}(9)=0;    %initialize
%check if block should be i
for i=1:CONSTANTS.Size  
    if sum(Puzzle(m,:)==i)==0 && sum(Puzzle(:,n)==i)==0 && sum(PuzSqID{box}==i)==0 && CONSTANTS.Puz_Pos_Forced{m,n}(i)~=1  %checks cloumn,row,sqr, and forced 0 struct
        Puz_Possibilities{m,n}(i)=1;
    else
        Puz_Possibilities{m,n}(i)=0;
    end    
end
end

%% Identifies the Square ID's of the puzzle
function PuzSqID=PuzzleSquareIdentifier(Puzzle)
global CONSTANTS


CONSTANTS.sqr{1}=[1,2,3,10,11,12,19,20,21];
CONSTANTS.sqr{2}=[4,5,6,13,14,15,22,23,24];
CONSTANTS.sqr{3}=[7,8,9,16,17,18,25,26,27];

CONSTANTS.sqr{4}=[28,29,30,37,38,39,46,47,48];
CONSTANTS.sqr{5}=[31,32,33,40,41,42,49,50,51];
CONSTANTS.sqr{6}=[34,35,36,43,44,45,52,53,54];

CONSTANTS.sqr{7}=[55,56,57,64,65,66,73,74,75];
CONSTANTS.sqr{8}=[58,59,60,67,68,69,76,77,78];
CONSTANTS.sqr{9}=[61,62,63,70,71,72,79,80,81];

PuzSqID{9}=[];
for i=1:CONSTANTS.Size
    PuzSqID{i}=Puzzle(CONSTANTS.sqr{i});
end
end


%% identifies the square of the blanks in the puzzle
% outputs an array just like m and n, of the blanks' square ID's
function Blanks_SquareID=SquareID(Index)
global CONSTANTS

sq{1}={1,2,3,10,11,12,19,20,21};
sq{2}={4,5,6,13,14,15,22,23,24};
sq{3}={7,8,9,16,17,18,25,26,27};

sq{4}={28,29,30,37,38,39,46,47,48};
sq{5}={31,32,33,40,41,42,49,50,51};
sq{6}={34,35,36,43,44,45,52,53,54};

sq{7}={55,56,57,64,65,66,73,74,75};
sq{8}={58,59,60,67,68,69,76,77,78};
sq{9}={61,62,63,70,71,72,79,80,81};

Blanks_SquareID=zeros(length(Index),1);
for i=1:length(Index)
    
    switch Index(i)
        case sq{1}
            Blanks_SquareID(i)=1;
        case sq{2}
            Blanks_SquareID(i)=2;
        case sq{3}
            Blanks_SquareID(i)=3;
        case sq{4}
            Blanks_SquareID(i)=4;
        case sq{5}
            Blanks_SquareID(i)=5;
        case sq{6}
            Blanks_SquareID(i)=6;
        case sq{7}
            Blanks_SquareID(i)=7;
        case sq{8}
            Blanks_SquareID(i)=8;
        case sq{9}
            Blanks_SquareID(i)=9;
    end

end
end